# avis-client
VUE Autonomous Visual Inspection System (AVIS)

This Python package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: 0.5.0
- Package version: 0.5.0
- Build package: org.openapitools.codegen.languages.PythonClientCodegen

## Requirements.

Python 3.7+

## Installation & Usage
### pip install

If the python package is hosted on a repository, you can install directly using:

```sh
pip install git+https://github.com/vuengineering/public.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/vuengineering/public.git`)

Then import the package:
```python
import avis_client
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import avis_client
```

### Tests

Execute `pytest` to run the tests.

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python

import time
import avis_client
from avis_client.rest import ApiException
from pprint import pprint

# Defining the host is optional and defaults to https://avis.vu.engineering
# See configuration.py for a list of all supported configuration parameters.
configuration = avis_client.Configuration(
    host = "https://avis.vu.engineering"
)

# The client must configure the authentication and authorization parameters
# in accordance with the API server security policy.
# Examples for each auth method are provided below, use the example that
# satisfies your auth use case.

# Configure API key authorization: cookieAuth
configuration.api_key['cookieAuth'] = os.environ["API_KEY"]

# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['cookieAuth'] = 'Bearer'

# Configure API key authorization: ApiKeyAuth
configuration.api_key['ApiKeyAuth'] = os.environ["API_KEY"]

# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['ApiKeyAuth'] = 'Bearer'


# Enter a context with an instance of the API client
with avis_client.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = avis_client.ApiKeysApi(api_client)
    user_api_key_create_request = avis_client.UserAPIKeyCreateRequest() # UserAPIKeyCreateRequest |  (optional)

    try:
        api_response = api_instance.keys_create(user_api_key_create_request=user_api_key_create_request)
        print("The response of ApiKeysApi->keys_create:\n")
        pprint(api_response)
    except ApiException as e:
        print("Exception when calling ApiKeysApi->keys_create: %s\n" % e)

```

## Documentation for API Endpoints

All URIs are relative to *https://avis.vu.engineering*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*ApiKeysApi* | [**keys_create**](docs/ApiKeysApi.md#keys_create) | **POST** /api/keys/ | 
*ApiKeysApi* | [**keys_revoke_create**](docs/ApiKeysApi.md#keys_revoke_create) | **POST** /api/keys/revoke/ | 
*ImageApi* | [**image_create**](docs/ImageApi.md#image_create) | **POST** /api/image/ | 
*ImageApi* | [**image_destroy**](docs/ImageApi.md#image_destroy) | **DELETE** /api/image/{id}/ | 
*ImageApi* | [**image_inspection_status_list**](docs/ImageApi.md#image_inspection_status_list) | **GET** /api/image/inspection_status/ | 
*ImageApi* | [**image_list**](docs/ImageApi.md#image_list) | **GET** /api/image/ | 
*ImageApi* | [**image_partial_update**](docs/ImageApi.md#image_partial_update) | **PATCH** /api/image/{id}/ | 
*ImageApi* | [**image_quality_list**](docs/ImageApi.md#image_quality_list) | **GET** /api/image/quality/ | 
*ImageApi* | [**image_retrieve**](docs/ImageApi.md#image_retrieve) | **GET** /api/image/{id}/ | 
*ImageApi* | [**image_update**](docs/ImageApi.md#image_update) | **PUT** /api/image/{id}/ | 
*ImageattributeApi* | [**imageattribute_create**](docs/ImageattributeApi.md#imageattribute_create) | **POST** /api/imageattribute/ | 
*ImageattributeApi* | [**imageattribute_destroy**](docs/ImageattributeApi.md#imageattribute_destroy) | **DELETE** /api/imageattribute/{id}/ | 
*ImageattributeApi* | [**imageattribute_list**](docs/ImageattributeApi.md#imageattribute_list) | **GET** /api/imageattribute/ | 
*ImageattributeApi* | [**imageattribute_partial_update**](docs/ImageattributeApi.md#imageattribute_partial_update) | **PATCH** /api/imageattribute/{id}/ | 
*ImageattributeApi* | [**imageattribute_retrieve**](docs/ImageattributeApi.md#imageattribute_retrieve) | **GET** /api/imageattribute/{id}/ | 
*ImageattributeApi* | [**imageattribute_update**](docs/ImageattributeApi.md#imageattribute_update) | **PUT** /api/imageattribute/{id}/ | 
*ImageattributecategoryApi* | [**imageattributecategory_create**](docs/ImageattributecategoryApi.md#imageattributecategory_create) | **POST** /api/imageattributecategory/ | 
*ImageattributecategoryApi* | [**imageattributecategory_destroy**](docs/ImageattributecategoryApi.md#imageattributecategory_destroy) | **DELETE** /api/imageattributecategory/{id}/ | 
*ImageattributecategoryApi* | [**imageattributecategory_list**](docs/ImageattributecategoryApi.md#imageattributecategory_list) | **GET** /api/imageattributecategory/ | 
*ImageattributecategoryApi* | [**imageattributecategory_partial_update**](docs/ImageattributecategoryApi.md#imageattributecategory_partial_update) | **PATCH** /api/imageattributecategory/{id}/ | 
*ImageattributecategoryApi* | [**imageattributecategory_retrieve**](docs/ImageattributecategoryApi.md#imageattributecategory_retrieve) | **GET** /api/imageattributecategory/{id}/ | 
*ImageattributecategoryApi* | [**imageattributecategory_update**](docs/ImageattributecategoryApi.md#imageattributecategory_update) | **PUT** /api/imageattributecategory/{id}/ | 
*ImagequalitygateApi* | [**imagequalitygate_create**](docs/ImagequalitygateApi.md#imagequalitygate_create) | **POST** /api/imagequalitygate/ | 
*ImagequalitygateApi* | [**imagequalitygate_destroy**](docs/ImagequalitygateApi.md#imagequalitygate_destroy) | **DELETE** /api/imagequalitygate/{id}/ | 
*ImagequalitygateApi* | [**imagequalitygate_list**](docs/ImagequalitygateApi.md#imagequalitygate_list) | **GET** /api/imagequalitygate/ | 
*ImagequalitygateApi* | [**imagequalitygate_partial_update**](docs/ImagequalitygateApi.md#imagequalitygate_partial_update) | **PATCH** /api/imagequalitygate/{id}/ | 
*ImagequalitygateApi* | [**imagequalitygate_retrieve**](docs/ImagequalitygateApi.md#imagequalitygate_retrieve) | **GET** /api/imagequalitygate/{id}/ | 
*ImagequalitygateApi* | [**imagequalitygate_update**](docs/ImagequalitygateApi.md#imagequalitygate_update) | **PUT** /api/imagequalitygate/{id}/ | 
*InspectionApi* | [**inspection_create**](docs/InspectionApi.md#inspection_create) | **POST** /api/inspection/ | 
*InspectionApi* | [**inspection_destroy**](docs/InspectionApi.md#inspection_destroy) | **DELETE** /api/inspection/{id}/ | 
*InspectionApi* | [**inspection_list**](docs/InspectionApi.md#inspection_list) | **GET** /api/inspection/ | 
*InspectionApi* | [**inspection_partial_update**](docs/InspectionApi.md#inspection_partial_update) | **PATCH** /api/inspection/{id}/ | 
*InspectionApi* | [**inspection_retrieve**](docs/InspectionApi.md#inspection_retrieve) | **GET** /api/inspection/{id}/ | 
*InspectionApi* | [**inspection_send_validation_email_retrieve**](docs/InspectionApi.md#inspection_send_validation_email_retrieve) | **GET** /api/inspection/{id}/send_validation_email/ | 
*InspectionApi* | [**inspection_status_list**](docs/InspectionApi.md#inspection_status_list) | **GET** /api/inspection/status/ | 
*InspectionApi* | [**inspection_update**](docs/InspectionApi.md#inspection_update) | **PUT** /api/inspection/{id}/ | 
*InspectionApi* | [**inspection_validation_status_list**](docs/InspectionApi.md#inspection_validation_status_list) | **GET** /api/inspection/validation_status/ | 
*InspectionmetadataApi* | [**inspectionmetadata_create**](docs/InspectionmetadataApi.md#inspectionmetadata_create) | **POST** /api/inspectionmetadata/ | 
*InspectionmetadataApi* | [**inspectionmetadata_destroy**](docs/InspectionmetadataApi.md#inspectionmetadata_destroy) | **DELETE** /api/inspectionmetadata/{id}/ | 
*InspectionmetadataApi* | [**inspectionmetadata_list**](docs/InspectionmetadataApi.md#inspectionmetadata_list) | **GET** /api/inspectionmetadata/ | 
*InspectionmetadataApi* | [**inspectionmetadata_partial_update**](docs/InspectionmetadataApi.md#inspectionmetadata_partial_update) | **PATCH** /api/inspectionmetadata/{id}/ | 
*InspectionmetadataApi* | [**inspectionmetadata_retrieve**](docs/InspectionmetadataApi.md#inspectionmetadata_retrieve) | **GET** /api/inspectionmetadata/{id}/ | 
*InspectionmetadataApi* | [**inspectionmetadata_update**](docs/InspectionmetadataApi.md#inspectionmetadata_update) | **PUT** /api/inspectionmetadata/{id}/ | 
*InspectionmetadataschemaApi* | [**inspectionmetadataschema_create**](docs/InspectionmetadataschemaApi.md#inspectionmetadataschema_create) | **POST** /api/inspectionmetadataschema/ | 
*InspectionmetadataschemaApi* | [**inspectionmetadataschema_destroy**](docs/InspectionmetadataschemaApi.md#inspectionmetadataschema_destroy) | **DELETE** /api/inspectionmetadataschema/{id}/ | 
*InspectionmetadataschemaApi* | [**inspectionmetadataschema_list**](docs/InspectionmetadataschemaApi.md#inspectionmetadataschema_list) | **GET** /api/inspectionmetadataschema/ | 
*InspectionmetadataschemaApi* | [**inspectionmetadataschema_partial_update**](docs/InspectionmetadataschemaApi.md#inspectionmetadataschema_partial_update) | **PATCH** /api/inspectionmetadataschema/{id}/ | 
*InspectionmetadataschemaApi* | [**inspectionmetadataschema_retrieve**](docs/InspectionmetadataschemaApi.md#inspectionmetadataschema_retrieve) | **GET** /api/inspectionmetadataschema/{id}/ | 
*InspectionmetadataschemaApi* | [**inspectionmetadataschema_update**](docs/InspectionmetadataschemaApi.md#inspectionmetadataschema_update) | **PUT** /api/inspectionmetadataschema/{id}/ | 
*InspectionprocessblueprintApi* | [**inspectionprocessblueprint_create**](docs/InspectionprocessblueprintApi.md#inspectionprocessblueprint_create) | **POST** /api/inspectionprocessblueprint/ | 
*InspectionprocessblueprintApi* | [**inspectionprocessblueprint_destroy**](docs/InspectionprocessblueprintApi.md#inspectionprocessblueprint_destroy) | **DELETE** /api/inspectionprocessblueprint/{id}/ | 
*InspectionprocessblueprintApi* | [**inspectionprocessblueprint_list**](docs/InspectionprocessblueprintApi.md#inspectionprocessblueprint_list) | **GET** /api/inspectionprocessblueprint/ | 
*InspectionprocessblueprintApi* | [**inspectionprocessblueprint_partial_update**](docs/InspectionprocessblueprintApi.md#inspectionprocessblueprint_partial_update) | **PATCH** /api/inspectionprocessblueprint/{id}/ | 
*InspectionprocessblueprintApi* | [**inspectionprocessblueprint_retrieve**](docs/InspectionprocessblueprintApi.md#inspectionprocessblueprint_retrieve) | **GET** /api/inspectionprocessblueprint/{id}/ | 
*InspectionprocessblueprintApi* | [**inspectionprocessblueprint_update**](docs/InspectionprocessblueprintApi.md#inspectionprocessblueprint_update) | **PUT** /api/inspectionprocessblueprint/{id}/ | 
*InspectionresultApi* | [**inspectionresult_create**](docs/InspectionresultApi.md#inspectionresult_create) | **POST** /api/inspectionresult/ | 
*InspectionresultApi* | [**inspectionresult_destroy**](docs/InspectionresultApi.md#inspectionresult_destroy) | **DELETE** /api/inspectionresult/{id}/ | 
*InspectionresultApi* | [**inspectionresult_list**](docs/InspectionresultApi.md#inspectionresult_list) | **GET** /api/inspectionresult/ | 
*InspectionresultApi* | [**inspectionresult_partial_update**](docs/InspectionresultApi.md#inspectionresult_partial_update) | **PATCH** /api/inspectionresult/{id}/ | 
*InspectionresultApi* | [**inspectionresult_retrieve**](docs/InspectionresultApi.md#inspectionresult_retrieve) | **GET** /api/inspectionresult/{id}/ | 
*InspectionresultApi* | [**inspectionresult_update**](docs/InspectionresultApi.md#inspectionresult_update) | **PUT** /api/inspectionresult/{id}/ | 
*MembershipApi* | [**membership_create**](docs/MembershipApi.md#membership_create) | **POST** /api/membership/ | 
*MembershipApi* | [**membership_destroy**](docs/MembershipApi.md#membership_destroy) | **DELETE** /api/membership/{id}/ | 
*MembershipApi* | [**membership_list**](docs/MembershipApi.md#membership_list) | **GET** /api/membership/ | 
*MembershipApi* | [**membership_retrieve**](docs/MembershipApi.md#membership_retrieve) | **GET** /api/membership/{id}/ | 
*MembershipApi* | [**membership_update**](docs/MembershipApi.md#membership_update) | **PUT** /api/membership/{id}/ | 
*MlApi* | [**ml_inspectionresult_create**](docs/MlApi.md#ml_inspectionresult_create) | **POST** /api/ml/inspectionresult/ | 
*MlApi* | [**ml_inspectionresult_destroy**](docs/MlApi.md#ml_inspectionresult_destroy) | **DELETE** /api/ml/inspectionresult/{id}/ | 
*MlApi* | [**ml_inspectionresult_list**](docs/MlApi.md#ml_inspectionresult_list) | **GET** /api/ml/inspectionresult/ | 
*MlApi* | [**ml_inspectionresult_partial_update**](docs/MlApi.md#ml_inspectionresult_partial_update) | **PATCH** /api/ml/inspectionresult/{id}/ | 
*MlApi* | [**ml_inspectionresult_retrieve**](docs/MlApi.md#ml_inspectionresult_retrieve) | **GET** /api/ml/inspectionresult/{id}/ | 
*MlApi* | [**ml_inspectionresult_update**](docs/MlApi.md#ml_inspectionresult_update) | **PUT** /api/ml/inspectionresult/{id}/ | 
*MlApi* | [**ml_model_create**](docs/MlApi.md#ml_model_create) | **POST** /api/ml/model/ | 
*MlApi* | [**ml_model_destroy**](docs/MlApi.md#ml_model_destroy) | **DELETE** /api/ml/model/{id}/ | 
*MlApi* | [**ml_model_inference**](docs/MlApi.md#ml_model_inference) | **POST** /api/ml/model/{id}/inference/ | 
*MlApi* | [**ml_model_list**](docs/MlApi.md#ml_model_list) | **GET** /api/ml/model/ | 
*MlApi* | [**ml_model_partial_update**](docs/MlApi.md#ml_model_partial_update) | **PATCH** /api/ml/model/{id}/ | 
*MlApi* | [**ml_model_retrieve**](docs/MlApi.md#ml_model_retrieve) | **GET** /api/ml/model/{id}/ | 
*MlApi* | [**ml_model_update**](docs/MlApi.md#ml_model_update) | **PUT** /api/ml/model/{id}/ | 
*MlApi* | [**ml_modeltype_create**](docs/MlApi.md#ml_modeltype_create) | **POST** /api/ml/modeltype/ | 
*MlApi* | [**ml_modeltype_destroy**](docs/MlApi.md#ml_modeltype_destroy) | **DELETE** /api/ml/modeltype/{id}/ | 
*MlApi* | [**ml_modeltype_list**](docs/MlApi.md#ml_modeltype_list) | **GET** /api/ml/modeltype/ | 
*MlApi* | [**ml_modeltype_partial_update**](docs/MlApi.md#ml_modeltype_partial_update) | **PATCH** /api/ml/modeltype/{id}/ | 
*MlApi* | [**ml_modeltype_retrieve**](docs/MlApi.md#ml_modeltype_retrieve) | **GET** /api/ml/modeltype/{id}/ | 
*MlApi* | [**ml_modeltype_update**](docs/MlApi.md#ml_modeltype_update) | **PUT** /api/ml/modeltype/{id}/ | 
*ProductApi* | [**product_create**](docs/ProductApi.md#product_create) | **POST** /api/product/ | 
*ProductApi* | [**product_destroy**](docs/ProductApi.md#product_destroy) | **DELETE** /api/product/{id}/ | 
*ProductApi* | [**product_list**](docs/ProductApi.md#product_list) | **GET** /api/product/ | 
*ProductApi* | [**product_partial_update**](docs/ProductApi.md#product_partial_update) | **PATCH** /api/product/{id}/ | 
*ProductApi* | [**product_retrieve**](docs/ProductApi.md#product_retrieve) | **GET** /api/product/{id}/ | 
*ProductApi* | [**product_update**](docs/ProductApi.md#product_update) | **PUT** /api/product/{id}/ | 
*ProductCategoryApi* | [**product_category_create**](docs/ProductCategoryApi.md#product_category_create) | **POST** /api/product-category/ | 
*ProductCategoryApi* | [**product_category_destroy**](docs/ProductCategoryApi.md#product_category_destroy) | **DELETE** /api/product-category/{id}/ | 
*ProductCategoryApi* | [**product_category_list**](docs/ProductCategoryApi.md#product_category_list) | **GET** /api/product-category/ | 
*ProductCategoryApi* | [**product_category_partial_update**](docs/ProductCategoryApi.md#product_category_partial_update) | **PATCH** /api/product-category/{id}/ | 
*ProductCategoryApi* | [**product_category_retrieve**](docs/ProductCategoryApi.md#product_category_retrieve) | **GET** /api/product-category/{id}/ | 
*ProductCategoryApi* | [**product_category_update**](docs/ProductCategoryApi.md#product_category_update) | **PUT** /api/product-category/{id}/ | 
*TeamApi* | [**team_create**](docs/TeamApi.md#team_create) | **POST** /api/team/ | 
*TeamApi* | [**team_destroy**](docs/TeamApi.md#team_destroy) | **DELETE** /api/team/{id}/ | 
*TeamApi* | [**team_list**](docs/TeamApi.md#team_list) | **GET** /api/team/ | 
*TeamApi* | [**team_retrieve**](docs/TeamApi.md#team_retrieve) | **GET** /api/team/{id}/ | 
*TeamApi* | [**team_update**](docs/TeamApi.md#team_update) | **PUT** /api/team/{id}/ | 
*UserApi* | [**user_email_list**](docs/UserApi.md#user_email_list) | **GET** /api/user/email/ | 
*UserApi* | [**user_whoami_retrieve**](docs/UserApi.md#user_whoami_retrieve) | **GET** /api/user/whoami/ | 


## Documentation For Models

 - [AzureMLInferenceRequest](docs/AzureMLInferenceRequest.md)
 - [BlankEnum](docs/BlankEnum.md)
 - [ClassificationResult](docs/ClassificationResult.md)
 - [ClassificationResultRequest](docs/ClassificationResultRequest.md)
 - [ClassificationResultStatus](docs/ClassificationResultStatus.md)
 - [CustomUser](docs/CustomUser.md)
 - [CustomUserRequest](docs/CustomUserRequest.md)
 - [EmailAddress](docs/EmailAddress.md)
 - [FormatEnum](docs/FormatEnum.md)
 - [Image](docs/Image.md)
 - [ImageAttribute](docs/ImageAttribute.md)
 - [ImageAttributeCategory](docs/ImageAttributeCategory.md)
 - [ImageAttributeCategoryRequest](docs/ImageAttributeCategoryRequest.md)
 - [ImageAttributeRequest](docs/ImageAttributeRequest.md)
 - [ImageQualityGate](docs/ImageQualityGate.md)
 - [ImageQualityGateRequest](docs/ImageQualityGateRequest.md)
 - [ImageQualityGateResult](docs/ImageQualityGateResult.md)
 - [ImageRequest](docs/ImageRequest.md)
 - [Inspection](docs/Inspection.md)
 - [InspectionMetadata](docs/InspectionMetadata.md)
 - [InspectionMetadataRequest](docs/InspectionMetadataRequest.md)
 - [InspectionMetadataSchema](docs/InspectionMetadataSchema.md)
 - [InspectionMetadataSchemaRequest](docs/InspectionMetadataSchemaRequest.md)
 - [InspectionProcessBlueprint](docs/InspectionProcessBlueprint.md)
 - [InspectionProcessBlueprintRequest](docs/InspectionProcessBlueprintRequest.md)
 - [InspectionRequest](docs/InspectionRequest.md)
 - [InspectionResultPolymorphic](docs/InspectionResultPolymorphic.md)
 - [InspectionResultPolymorphicRequest](docs/InspectionResultPolymorphicRequest.md)
 - [InspectionStatus](docs/InspectionStatus.md)
 - [InspectionStatusEnum](docs/InspectionStatusEnum.md)
 - [InspectionValidationStatus](docs/InspectionValidationStatus.md)
 - [MLModel](docs/MLModel.md)
 - [MLModelRequest](docs/MLModelRequest.md)
 - [MLModelType](docs/MLModelType.md)
 - [MLModelTypeRequest](docs/MLModelTypeRequest.md)
 - [Membership](docs/Membership.md)
 - [MembershipRequest](docs/MembershipRequest.md)
 - [PatchedClassificationResultRequest](docs/PatchedClassificationResultRequest.md)
 - [PatchedImageAttributeCategoryRequest](docs/PatchedImageAttributeCategoryRequest.md)
 - [PatchedImageAttributeRequest](docs/PatchedImageAttributeRequest.md)
 - [PatchedImageQualityGateRequest](docs/PatchedImageQualityGateRequest.md)
 - [PatchedImageRequest](docs/PatchedImageRequest.md)
 - [PatchedInspectionMetadataRequest](docs/PatchedInspectionMetadataRequest.md)
 - [PatchedInspectionMetadataSchemaRequest](docs/PatchedInspectionMetadataSchemaRequest.md)
 - [PatchedInspectionProcessBlueprintRequest](docs/PatchedInspectionProcessBlueprintRequest.md)
 - [PatchedInspectionRequest](docs/PatchedInspectionRequest.md)
 - [PatchedInspectionResultPolymorphicRequest](docs/PatchedInspectionResultPolymorphicRequest.md)
 - [PatchedMLModelRequest](docs/PatchedMLModelRequest.md)
 - [PatchedMLModelTypeRequest](docs/PatchedMLModelTypeRequest.md)
 - [PatchedProductCategoryRequest](docs/PatchedProductCategoryRequest.md)
 - [PatchedProductRequest](docs/PatchedProductRequest.md)
 - [PatchedRatingInspectionResultRequest](docs/PatchedRatingInspectionResultRequest.md)
 - [PatchedRatingInspectionResultTypedRequest](docs/PatchedRatingInspectionResultTypedRequest.md)
 - [Product](docs/Product.md)
 - [ProductCategory](docs/ProductCategory.md)
 - [ProductCategoryRequest](docs/ProductCategoryRequest.md)
 - [ProductRequest](docs/ProductRequest.md)
 - [QualityEnum](docs/QualityEnum.md)
 - [RatingInspectionResult](docs/RatingInspectionResult.md)
 - [RatingInspectionResultRequest](docs/RatingInspectionResultRequest.md)
 - [RatingInspectionResultTyped](docs/RatingInspectionResultTyped.md)
 - [RatingInspectionResultTypedRequest](docs/RatingInspectionResultTypedRequest.md)
 - [StatusEnum](docs/StatusEnum.md)
 - [Team](docs/Team.md)
 - [TeamRequest](docs/TeamRequest.md)
 - [TypeEnum](docs/TypeEnum.md)
 - [UserAPIKeyCreate](docs/UserAPIKeyCreate.md)
 - [UserAPIKeyCreateRequest](docs/UserAPIKeyCreateRequest.md)
 - [ValidationStatusEnum](docs/ValidationStatusEnum.md)


<a id="documentation-for-authorization"></a>
## Documentation For Authorization


Authentication schemes defined for the API:
<a id="ApiKeyAuth"></a>
### ApiKeyAuth

- **Type**: API key
- **API key parameter name**: X-Api-Key
- **Location**: HTTP header

<a id="cookieAuth"></a>
### cookieAuth

- **Type**: API key
- **API key parameter name**: sessionid
- **Location**: 


## Author




